#!/usr/bin/perl
use ConfigReader;
use strict;
use DBI;
use CGI qw/-nodebug/;

config_default();
my %c = config_read(1);

my $q = new CGI;
my %user_env = $q->cookie('settings');
print $q->header;

my $prev = "History: | ";
my $prev_add = "";

#foreach (keys %user_env) {print "$_ $user_env{$_}<br>"};

open (IN, $q->param('mode') eq 'complex' ? "<index_raw_complex.html" : "<index_raw_simple.html");
my @html = <IN>;
close IN;
$_ = join('', @html);

if (!defined %user_env)
{
	s/#searchstring//;
	s/#chk_normal/ checked/;
	s/#chk_wildcards//;
	s/#chk_regex//;
	s/#chk_online//;
	s/#chk_startdate//;
	s/#chk_cookie//;
	s/#minfilesize//;
	s/#maxfilesize//;
	s/#query[0-9]//g;
	s/#previous_searches//;
}
else
{
	my $chk = " checked";
	
	my $chk_normal = "";
	my $chk_wildcards = "";
	my $chk_regex = "";
	
	($user_env{mode} == 0) ? $chk_normal = $chk :
				 ($user_env{mode} == 2 ? $chk_regex = $chk : $chk_wildcards = $chk);
	my $searchstring = $user_env{searchstring};
	my $chk_online = ($user_env{online} == 1) ? $chk : "";
	my $chk_startdate = ($user_env{date} == 1) ? $chk : "";
	my $chk_guess = ($user_env{guess} == 1) ? $chk : "";
	
	s/#searchstring/$searchstring/;
	s/#chk_normal/$chk_normal/;
	s/#chk_wildcards/$chk_wildcards/;
	s/#chk_regex/$chk_regex/;
	s/#chk_online/$chk_online/;
	s/#chk_startdate/$chk_startdate/;
	s/#chk_cookie/$chk/;
	s/#minfilesize/$user_env{minfilesize}/;
	s/#maxfilesize/$user_env{maxfilesize}/;
	s/(option)(> $user_env{datemonth})/\1 selected\2/;
	s/(option)(> $user_env{dateday})/\1 selected\2/;
	s/(option)(> $user_env{dateyear})/\1 selected\2/;
	
	for (my $i = 0; $i < 10; $i++)
	{
		my $content = $user_env{"query$i"};
		if ($content ne "")
		{
			s/"#query$i"/$content/;
			$content =~ s/^'(.*?[^\\])'.*/\1/;
			$prev_add .= "<a href=\"javascript:suche($i)\">$content</a> |";
		}
		else
		{
			s/"#query$i"/$content/;
		}
	}
	
	$prev_add ne "" ? s/#previous_searches/$prev$prev_add/ : s/#previous_searches//;
}

my $db = DBI->connect($c{DB_NAME}, "search") || die $DBI::errstring;
(my $num_files, my $sum_filesize, my $smb_hosts, my $ftp_hosts, my $max_dateadded) = $db->selectrow_array("SELECT * FROM Status");
my $upt = $db->prepare("SHOW STATUS");
$upt->execute();

my @res = ();
my $queries = '';

for (my $count = 0; $count < 30; $count++)
{
	@res = $upt->fetchrow_array();
	$queries = $res[1] if ($count == 26);
}
(my $u_sec, my $u_min, my $u_hour, my $u_day, my $u_month, my $u_year) = localtime $res[1];
$upt->finish();
#$u_hour--;
#$u_year -= 70;
$u_day--;
$db->disconnect();

s/#num_files/$num_files/;
s/#sum_filesize/$sum_filesize/;
s/#smb_hosts/$smb_hosts/;
s/#ftp_hosts/$ftp_hosts/;
s/#max_dateadded/$max_dateadded/;
s/#uptime/${u_month}m&nbsp;${u_day}d&nbsp;${u_hour}h&nbsp;${u_min}m/;
s/#queries/$queries/;
print $_;
