#!/usr/bin/perl
use CGI qw/-nodebug/;
use ConfigReader;
#use strict;

config_default();   
my %c = config_read();

my $q = new CGI;
my $cmd = $q->param('command');

if ($cmd eq 'list')
{
    display_ftps_in_database();
}
elsif ($cmd eq 'add')
{
    add_ftp();
}

sub add_ftp
{
    print $q->header;
    my $host = uc $q->param('host');
    my $login = $q->param('login');
    my $password = $q->param('password');
    my $port = $q->param('port');
    my $comment = $q->param('comment');
    
    open (IN, "ftp.html");
    my @html = <IN>;
    $output = join('', @html); 
    close IN;

    my $errormsg = '';
    
    $errormsg .= "Host fehlt!<br>" if (!defined $host);
    $errormsg .= "Login fehlt!<br>" if (!defined $login);
    $errormsg .= "Passwort fehlt!<br>" if (!defined $password);
    $errormsg .= "Port fehlt!<br>" if (!defined $port);
    $errormsg .= "Port ungueltig!<br>" if ($port < 1 && $port > 65535);
    my @out = `$c{SMB_PATH}/nmblookup -r $host`;
    $errormsg .= "Kein gueltiger Hostname. Bitte Windows-Rechnernamen angeben!<br>" if ($out[1] =~ /failed/);
    
    if ($errormsg ne '')
    {
	$output =~ s/#ftp/$errormsg/;
    }
    else
    {
	my @list = read_ftp_list();
	my $index = 0;
#	my $found = undef;
#	while ($index < @list && !$found)
#	{
#	    $list[$index] =~ /^(.*?)#__/;
#	    $found = 1 if ($1 eq $host);
#	    $index++;
#	}
#	if ($found)
#	{
#	    $output =~ s/#ftp/Host schon vorhanden./;
#	}
#	else
#	{
	    push @list, join ('#__', ($host, $login, $password, $port, $comment)). "\n";
	    write_ftp_list(\@list);
	    $output =~ s/#ftp/Host eingetragen./;
#	}
    }
     
    print $output;
}

sub read_ftp_list
{
    open (IN, "<ftp_list");
    my @list = <IN>;
    close IN;
    return @list;
}

sub write_ftp_list
{
    (my $list) = @_;
    
    open (OUT, ">ftp_list") || die "$!";
    foreach (@$list)
    {
	print OUT "$_";
    }
    close OUT;
}

sub display_ftps_in_database
{
    print $q->header;

    open (IN, "ftp.html");
    my @html = <IN>;
    $_ = join('', @html); 
    close IN;

    my $table;
    my $fopen = '<td bgcolor="#dddddd"><font face="verdana, helvetica" size="2">';
    my $fclose = '</font></td>';
    my $hopen = '<th align="left" bgcolor="#cccccc"><font face="verdana, helvetica" size="2">';
    my $hclose = '</font></th>';

    my @list = read_ftp_list();
    foreach (@list)
    {
	chomp;
	my @parts = split(/#__/, $_);

	# netscape workaround for empty rows
	if (!defined $parts[4])
	{
	    $parts[4] = '&nbsp;';
	}

#	ftp links deactivated
#	if ($parts[1] eq "anonymous" && $parts[2] eq "user\@host.com")
#	{
#	    $lopen = "<a href=\"ftp://$parts[0]:$parts[3]/\">";
#	}
#	else
#	{
#	    $lopen = "<a href=\"ftp://$parts[1]:$parts[2]\@$parts[0]:$parts[3]/\">";
#	}
#	$lclose = "</a>";
	
	$table .= qq{
	<tr>
	$fopen$lopen$parts[0]$lclose$fclose$fopen$parts[1]$fclose$fopen$parts[2]$fclose
	<td align="right" bgcolor="#dddddd"><font face="verdana, helvetica" size="2">$parts[3]$fclose$fopen$parts[4]$fclose
	</tr>
	};	
    }
    if (@list == 0)
    {
	s/#ftp/Keine Hosts vorhanden/;
    }
    else
    {
	my $header = qq{
<table cellpadding=3 cellspacing=1 border=0 width=70%>
<tr>
$hopen Host $hclose
$hopen Login $hclose
$hopen PassWord $hclose
$hopen Port $hclose
$hopen Kommentar $hclose
</tr>
};
	my $trailer = sprintf "<p>[%d Server]", $#list+1;

	$table = $header . $table . '</table>' . $trailer;
	s/#ftp/$table/;
    }

    print $_;
}
